; AILang generated workspace; entry: ws_main
source_filename = "ws_main.ail"
target triple = "<NORMALIZED>"

@.str_ws_main_fmt_int_0 = private unnamed_addr constant [6 x i8] c"%lld\0A\00", align 1

declare i32 @printf(ptr, ...)
declare i32 @puts(ptr)
declare ptr @GC_malloc(i64)
declare i32 @strcmp(ptr, ptr)
declare zeroext i1 @ail_str_eq(ptr, ptr)
declare i32 @ail_str_compare(ptr, ptr)
declare i64 @llvm.fptosi.sat.i64.f64(double)

@ail_ws_lib_add_clos = private unnamed_addr constant { ptr, ptr } { ptr @ail_ws_lib_add_adapter, ptr null }
@ail_ws_main_main_clos = private unnamed_addr constant { ptr, ptr } { ptr @ail_ws_main_main_adapter, ptr null }
define i64 @ail_ws_lib_add(i64 %arg_a, i64 %arg_b) {
entry:
  %v1 = add i64 %arg_a, %arg_b
  ret i64 %v1
}

define i64 @ail_ws_lib_add_adapter(ptr %_env, i64 %a0, i64 %a1) {
entry:
  %r = call i64 @ail_ws_lib_add(i64 %a0, i64 %a1)
  ret i64 %r
}

define i8 @ail_ws_main_main() {
entry:
  %v1 = call i64 @ail_ws_lib_add(i64 2, i64 3)
  call i32 (ptr, ...) @printf(ptr @.str_ws_main_fmt_int_0, i64 %v1)
  ret i8 0
}

define i8 @ail_ws_main_main_adapter(ptr %_env) {
entry:
  %r = call i8 @ail_ws_main_main()
  ret i8 %r
}


define i32 @main() {
  call i8 @ail_ws_main_main()
  ret i32 0
}
